---
 config/examples/amd64_rules.xml         |    2 +-
 config/examples/cross-ppc_rules.xml     |    4 ++--
 config/examples/cross-sparc32_rules.xml |    4 ++--
 config/examples/cross-sparc64_rules.xml |    4 ++--
 config/examples/sparc32_rules.xml       |    4 ++--
 config/examples/sparc64_rules.xml       |    4 ++--
 config/examples/x86_rules.xml           |    2 +-
 7 files changed, 12 insertions(+), 12 deletions(-)

Index: openbios-devel/config/examples/amd64_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/amd64_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/amd64_rules.xml	2008-12-04 00:47:00.000000000 +0100
@@ -34,7 +34,7 @@
 
 $(ODIR)/forth/version.fs:
 	@test -d $(dir $@) || $(INSTALL) -d $(dir $@)
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs
Index: openbios-devel/config/examples/cross-ppc_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/cross-ppc_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/cross-ppc_rules.xml	2008-12-04 00:47:23.000000000 +0100
@@ -40,13 +40,13 @@
 versions: $(ODIR)/target/include/openbios-version.h $(ODIR)/forth/version.fs
 
 $(ODIR)/forth/version.fs:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs
 
 $(ODIR)/target/include/openbios-version.h:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ; \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ; \
           ( echo "#define OPENBIOS_BUILD_DATE \"$$DATE\"" ; \
            echo "#define OPENBIOS_VERSION_STR \"$(VERSION)\"" ; \
            echo "#define OPENBIOS_RELEASE \"$(VERSION)\"" ; ) \
Index: openbios-devel/config/examples/cross-sparc32_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/cross-sparc32_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/cross-sparc32_rules.xml	2008-12-04 00:47:32.000000000 +0100
@@ -38,13 +38,13 @@
 versions: $(ODIR)/target/include/openbios-version.h $(ODIR)/forth/version.fs
 
 $(ODIR)/forth/version.fs:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs
 
 $(ODIR)/target/include/openbios-version.h:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ; \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ; \
           ( echo "#define OPENBIOS_BUILD_DATE \"$$DATE\"" ; \
            echo "#define OPENBIOS_VERSION_STR \"$(VERSION)\"" ; \
            echo "#define OPENBIOS_RELEASE \"$(VERSION)\"" ; ) \
Index: openbios-devel/config/examples/cross-sparc64_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/cross-sparc64_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/cross-sparc64_rules.xml	2008-12-04 00:47:37.000000000 +0100
@@ -39,13 +39,13 @@
 versions: $(ODIR)/target/include/openbios-version.h $(ODIR)/forth/version.fs
 
 $(ODIR)/forth/version.fs:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs
 
 $(ODIR)/target/include/openbios-version.h:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ; \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ; \
           ( echo "#define OPENBIOS_BUILD_DATE \"$$DATE\"" ; \
            echo "#define OPENBIOS_VERSION_STR \"$(VERSION)\"" ; \
            echo "#define OPENBIOS_RELEASE \"$(VERSION)\"" ; ) \
Index: openbios-devel/config/examples/sparc32_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/sparc32_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/sparc32_rules.xml	2008-12-04 00:47:41.000000000 +0100
@@ -43,13 +43,13 @@
 versions: $(ODIR)/target/include/openbios-version.h $(ODIR)/forth/version.fs
 
 $(ODIR)/forth/version.fs:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs
 
 $(ODIR)/target/include/openbios-version.h:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ; \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ; \
           ( echo "#define OPENBIOS_BUILD_DATE \"$$DATE\"" ; \
            echo "#define OPENBIOS_VERSION_STR \"$(VERSION)\"" ; \
            echo "#define OPENBIOS_RELEASE \"$(VERSION)\"" ; ) \
Index: openbios-devel/config/examples/sparc64_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/sparc64_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/sparc64_rules.xml	2008-12-04 00:47:45.000000000 +0100
@@ -50,13 +50,13 @@
 versions: $(ODIR)/target/include/openbios-version.h $(ODIR)/forth/version.fs
 
 $(ODIR)/forth/version.fs:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs
 
 $(ODIR)/target/include/openbios-version.h:
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ; \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ; \
           ( echo "#define OPENBIOS_BUILD_DATE \"$$DATE\"" ; \
            echo "#define OPENBIOS_VERSION_STR \"$(VERSION)\"" ; \
            echo "#define OPENBIOS_RELEASE \"$(VERSION)\"" ; ) \
Index: openbios-devel/config/examples/x86_rules.xml
===================================================================
--- openbios-devel.orig/config/examples/x86_rules.xml	2008-12-04 00:46:57.000000000 +0100
+++ openbios-devel/config/examples/x86_rules.xml	2008-12-04 00:47:00.000000000 +0100
@@ -38,7 +38,7 @@
 
 $(ODIR)/forth/version.fs:
 	@test -d $(dir $@) || $(INSTALL) -d $(dir $@)
-	@DATE="$(shell echo `date +'%b %e %Y %H:%M'`)" ;  \
+	@DATE="$(shell echo `LANG=C date +'%b %e %Y %H:%M'`)" ;  \
 		( echo ": builddate \" $$DATE\" ; " ;     \
 		  echo ": version \" $(VERSION)\" ; " ; ) \
 		  > $(dir $@)/version.fs